/*
  Made by Cicely 2021
  This program will test the three RGB LEDs at once
*/
#define BUTTON 4
#define LED_BLUE 8
#define LED_GREEN 6
#define LED_RED 7
#define LEDA 10
#define LEDB 9
#define LEDC 0
#define LEDD 1
#define LEDE 2
#define LEDF 3

int button_pressed = 0;

void checkButton() {
  // Adds 1 to the counter each time the button is pressed
  if (digitalRead(BUTTON)) {
    button_pressed = button_pressed + digitalRead(BUTTON);
    delay(200);
  }
}

void delayIfNotPressed(int delSpeed2) {
  if (digitalRead(BUTTON)) {
    return;
  } else {
    delay(delSpeed2);
  }
}

void leftToRight(int delSpeed) {
  digitalWrite(LEDA, HIGH); // flash each led quickly
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDA, LOW);

  digitalWrite(LEDB, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);

  digitalWrite(LEDC, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDC, LOW);

  digitalWrite(LEDD, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDD, LOW);

  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDE, LOW);

  digitalWrite(LEDF, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDF, LOW);
}

void middleOut(int delSpeed) {
  digitalWrite(LEDA, HIGH); // flash each led quickly
  digitalWrite(LEDF, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDA, LOW);
  digitalWrite(LEDF, LOW);

  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDE, LOW);

  digitalWrite(LEDC, HIGH);
  digitalWrite(LEDD, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDC, LOW);
  digitalWrite(LEDD, LOW);

}

void setRGB (int red, int green, int blue)  {
  analogWrite(LED_RED, 255 - red);
  analogWrite(LED_GREEN, 255 - green);
  analogWrite(LED_BLUE, 255 - blue);
}

void sweep(int delSpeed) {
  digitalWrite(LEDA, HIGH); // flash each led quickly
  digitalWrite(LEDF, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDA, LOW);
  digitalWrite(LEDF, LOW);

  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDE, LOW);

  digitalWrite(LEDC, HIGH);
  digitalWrite(LEDD, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDC, LOW);
  digitalWrite(LEDD, LOW);

  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);
  delayIfNotPressed(delSpeed);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDE, LOW);
}

void alwaysOn() {
  digitalWrite(LEDB, HIGH);
  digitalWrite(LEDE, HIGH);

}

// the setup function runs once when you press reset or power the board
void setup() {
  pinMode(BUTTON, OUTPUT);  // Technically the button is an input, but because it kept triggering itself we've configured it to sink current so it doesn't accidentally trigger
  pinMode(LED_BLUE, OUTPUT);
  pinMode(LED_GREEN, OUTPUT);
  pinMode(LED_RED, OUTPUT);
  pinMode(LEDA, OUTPUT);
  pinMode(LEDB, OUTPUT);
  pinMode(LEDC, OUTPUT);
  pinMode(LEDD, OUTPUT);
  pinMode(LEDE, OUTPUT);
  pinMode(LEDF, OUTPUT);

  digitalWrite(LED_RED, HIGH);//LED outputs are inverted!!!!!
  digitalWrite(LED_GREEN, HIGH);//that means high is off and low is on!!!! :(
  digitalWrite(LED_BLUE, HIGH);
  digitalWrite(LEDA, LOW);
  digitalWrite(LEDB, LOW);
  digitalWrite(LEDC, LOW);
  digitalWrite(LEDD, LOW);
  digitalWrite(LEDE, LOW);
  digitalWrite(LEDF, LOW);
}

// the loop function runs over and over again forever
void loop() {

  checkButton();
  if (button_pressed == 1) { //this is a reading light mode
    setRGB (100, 250, 230);
    alwaysOn();
  }

  if (button_pressed == 2) {
    setRGB (255, 0, 0);
    sweep(100);

    setRGB (100, 0, 0);
    sweep(100);

    setRGB (0, 0, 255);
    sweep(100);
  }

  if (button_pressed == 3) {
    setRGB (100, 255, 100);
    leftToRight(100);

    setRGB (210, 255, 0);
    leftToRight(100);

    setRGB (255, 60, 0);
    leftToRight(100);
  }
  if (button_pressed == 4) {
    button_pressed = 0; //this will repeat the cycle by resetting the counter
    delay (500);
  }
}
